using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Telerik.OpenAccess;

namespace AuditTrailExample
{
    public class Product : IInstanceCallbacks
    {
        public int ID { get; set; }
        public string ProductName { get; set; }
        public decimal Price { get; set; }

        public void PreStore()
        {
            Telerik.OpenAccess.SPI.IExtendedObjectScope scope = Database.GetContext(this) as Telerik.OpenAccess.SPI.IExtendedObjectScope;
            AuditTrailExampleContext context = scope.UserContext as AuditTrailExampleContext;
            if (context != null && context.GetState(this) == ObjectState.Dirty)
            {
                var key = context.CreateObjectKey(this);
                context.AddChangedAudit();
                
                //OR USE THE FOLLOWING APPROACH
                //Create the Audit object 
                //var audit = new Audit() { ObjectId = key.ToString(), Action = Audit.AuditAction.Update, ClassName = key.TypeName, AuditDate = DateTime.Now };
                //set the old,new values 
                //var oldProductName = context.GetOriginalValue<object>(this, "ProductName");
                //var newValue = this.ProductName;
                //var oldPrice = context.GetOriginalValue<object>(this, "Price");
                //context.Add(audit);
            }
        }

        public void PostLoad()
        {
            
        }

        public void PreRemove(IObjectScope objectScope)
        {
            
        }
    }
}
