﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace AuditTrailExample
{
    class Program
    {
        static void Main(string[] args)
        {
            // audit trail handling is implemented in the AuditTrailExampleContext class

            var ctx = new AuditTrailExampleContext(true);
            ctx.UpdateSchema();
            ctx = new AuditTrailExampleContext(false);

            ctx.Add(new Product(){ ProductName = "new product"});
            ctx.SaveChanges();
            Console.WriteLine("After insert: " + ctx.GetAll<Audit>().Count());
            var p = ctx.GetAll<Product>().First();
            p.ProductName = "changed product";
            p.Price++;
            ctx.SaveChanges();
            Console.WriteLine("After update: " + ctx.GetAll<Audit>().Count());
            ctx.Delete(p);
            ctx.SaveChanges();
            Console.WriteLine("After delete: " + ctx.GetAll<Audit>().Count());

            foreach(var a in ctx.GetAll<Audit>())
                Console.WriteLine(a);
        }
    }
}
